// CsTokenTypes.hpp

#ifndef _CS_TOKEN_TYPE_H_
#define _CS_TOKEN_TYPE_H_

enum CsTokenType
{
#if !CS_PARSER2
	tkEOF = 0,
	tkINVALID = 1,
	tkPP_INVALID = 2,

// tokens skipped in compilation parser

	tkWS = 3,
	tkNEW_LINE = 4,
	tkSL_COMMENT = 5,
	tkML_COMMENT = 6,

// keywords

	tkABSTRACT = 7,
	tkAS = 8,
	tkBASE = 9,
	tkBOOL = 10,
	tkBREAK = 11,
	tkBYTE = 12,
	tkCASE = 13,
	tkCATCH = 14,
	tkCHAR = 15,
	tkCHECKED = 16,
	tkCLASS = 17,
	tkCONST = 18,
	tkCONTINUE = 19,
	tkDECIMAL = 20,
	tkDEFAULT = 21,
	tkDELEGATE = 22,
	tkDO = 23,
	tkDOUBLE = 24,
	tkELSE = 25,
	tkENUM = 26,
	tkEVENT = 27,
	tkEXPLICIT = 28,
	tkEXTERN = 29,
	tkFALSE = 30,
	tkFINALLY = 31,
	tkFIXED = 32,
	tkFLOAT = 33,
	tkFOR = 34,
	tkFOREACH = 35,
	tkGOTO = 36,
	tkIF = 37,
	tkIMPLICIT = 38,
	tkIN = 39,
	tkINT = 40,
	tkINTERFACE = 41,
	tkINTERNAL = 42,
	tkIS = 43,
	tkLOCK = 44,
	tkLONG = 45,
	tkNAMESPACE = 46,
	tkNEW = 47,
	tkNULL = 48,
	tkOBJECT = 49,
	tkOPERATOR = 50,
	tkOUT = 51,
	tkOVERRIDE = 52,
	tkPARAMS = 53,
	tkPRIVATE = 54,
	tkPROTECTED = 55,
	tkPUBLIC = 56,
	tkREADONLY = 57,
	tkREF = 58,
	tkRETURN = 59,
	tkSBYTE = 60,
	tkSEALED = 61,
	tkSHORT = 62,
	tkSIZEOF = 63,
	tkSTACKALLOC = 64,
	tkSTATIC = 65,
	tkSTRING = 66,
	tkSTRUCT = 67,
	tkSWITCH = 68,
	tkTHIS = 69,
	tkTHROW = 70,
	tkTRUE = 71,
	tkTRY = 72,
	tkTYPEOF = 73,
	tkUINT = 74,
	tkULONG = 75,
	tkUNCHECKED = 76,
	tkUNSAFE = 77,
	tkUSHORT = 78,
	tkUSING = 79,
	tkVIRTUAL = 80,
	tkVOID = 81,
	tkVOLATILE = 82,
	tkWHILE = 83,

	tkLPAREN = 84,            // (
	tkRPAREN = 85,            // )
	tkLBRACKET = 86,          // [
	tkRBRACKET = 87,          // ]
	tkLCURLY = 88,            // {
	tkRCURLY = 89,            // }
	tkQUESTION = 90,          // ?
	tkCOLON = 91,             // :
	tkSEMICOLON = 92,         // ;
	tkCOMMA = 93,             // ,
	tkASSIGN = 94,            // =
	tkEQUAL = 95,             // ==
	tkNOT_EQ = 96,            // !=
	tkPLUS = 97,              // +
	tkPLUS_EQ = 98,           // +=
	tkINC = 99,               // ++
	tkMINUS = 100,            // -
	tkMINUS_EQ = 101,         // -=
	tkDEC = 102,              // --
	tkSTAR = 103,             // *
	tkMUL_EQ = 104,            // *=
	tkDIV = 105,               // /
	tkDIV_EQ = 106,            // /=
	tkMOD = 107,               // %
	tkMOD_EQ = 108,            // %=
	tkSHIFT_LEFT = 109,        // <<
	tkSHIFT_LEFT_EQ = 110,     // <<=
	tkSHIFT_RIGHT = 111,       // >>
	tkSHIFT_RIGHT_EQ = 112,    // >>=
	tkLESS = 113,              // <
	tkGREATER = 114,           // >
	tkLESS_OR_EQUAL = 115,    // <=
	tkGREATER_OR_EQUAL = 116, // >=
	tkNOT = 117,              // !
	tkCOMPL = 118,            // ~
	tkXOR = 119,              // ^
	tkXOR_EQ = 120,           // ^=
	tkBITOR = 121,            // |
	tkOR_EQ = 122,            // |=
	tkOR = 123,               // ||
	tkBITAND = 124,           // &
	tkAND_EQ = 125,           // &=
	tkAND = 126,              // &&
	tkDOT = 127,              // .
	tkARROW = 128,            // ->

	tkLITERAL = 129,
	tkIDENTIFIER = 130,

// used for operator priority

	tkUNARY_PLUS = 131,
	tkUNARY_MINUS = 132,
	tkUNARY_STAR = 133,
	tkUNARY_AMPERSAND = 134,

// Microsoft extensions

	tkMAKEREF = 135,
	tkREFTYPE = 136,
	tkREFVALUE = 137,
	tkARGLIST = 138,

	tkPND = 139,              // #
	//tkAT = 140,               // @

// preprocessor keywords

	tkPP_IF = 141,
	tkPP_ELIF = 142,
	tkPP_ELSE = 143,
	tkPP_ENDIF = 144,
	tkPP_DEFINE = 145,
	tkPP_UNDEF = 146,
	tkPP_LINE = 147,
	tkPP_ERROR = 148,
	tkPP_WARNING = 149,
	tkPP_REGION = 150,
	tkPP_ENDREGION = 151,
	tkPP_PRAGMA = 152,

// other preprocessor tokens

	tkPP_MESSAGE = 153, // not contain newline
	tkPP_DECIMAL_DIGITS = 154, // #line support
	tkPP_FILE_NAME = 155, // #line support
	tkPP_PRAGMA_TEXT = 156, // not contain newline
	tkPP_SKIPPED_SECTION = 157,

// parser tokens

	TOKEN_COUNT = 158,


#else
#endif // !CS_PARSER2
};

enum LineEnum
{
	windows_line = 0, // \r\n
	unix_line = 1, // \n
	mac_line = 2, // \r
};

#if CS_PARSER2
#endif // CS_PARSER2

const char * token_type_to_text ( CsTokenType type );
const char * line_type_to_text ( LineEnum type );


#endif // _CS_TOKEN_TYPE_H_
